import { IResolvers, IFieldResolver } from '@graphql-toolkit/common';
import { GraphQLSchema, DocumentNode, GraphQLField, GraphQLInputType } from 'graphql';
export interface IResolverValidationOptions {
    requireResolversForArgs?: boolean;
    requireResolversForNonScalar?: boolean;
    requireResolversForAllFields?: boolean;
    requireResolversForResolveType?: boolean;
    allowResolversNotInSchema?: boolean;
}
export interface IAddResolversToSchemaOptions {
    schema: GraphQLSchema;
    resolvers: IResolvers;
    defaultFieldResolver?: IFieldResolver<any, any>;
    resolverValidationOptions?: IResolverValidationOptions;
    inheritResolversFromInterfaces?: boolean;
}
export declare type ITypedef = (() => Array<ITypedef>) | string | DocumentNode;
export declare type ITypeDefinitions = ITypedef | Array<ITypedef>;
export declare type IDefaultValueIteratorFn = (type: GraphQLInputType, value: any) => void;
export interface IExecutableSchemaDefinition<TContext = any> {
    typeDefs: ITypeDefinitions;
    resolvers?: IResolvers<any, TContext> | Array<IResolvers<any, TContext>>;
    resolverValidationOptions?: IResolverValidationOptions;
    parseOptions?: GraphQLParseOptions;
    inheritResolversFromInterfaces?: boolean;
}
export interface GraphQLParseOptions {
    noLocation?: boolean;
    allowLegacySDLEmptyFields?: boolean;
    allowLegacySDLImplementsInterfaces?: boolean;
    experimentalFragmentVariables?: boolean;
}
export declare type IndexedObject<V> = {
    [key: string]: V;
} | ReadonlyArray<V>;
export declare type IFieldIteratorFn = (fieldDef: GraphQLField<any, any>, typeName: string, fieldName: string) => void;
